# DataStax Enterprise PHP Driver

A driver built specifically for the [DataStax Enterprise][DSE] (DSE). It builds
on the [DataStax PHP driver for Apache Cassandra] and includes specific
features for DSE.

This software can be used solely with [DataStax Enterprise][DSE]. See the
[License section](#licence) below.

__Note__: DataStax products do not support big-endian systems.

## Getting the Driver

Binary versions of the driver, available for multiple operating systems and
multiple versions of PHP, can be obtained from our [download server]. The
source code is made available via [GitHub].

## Features

### DSE v5.0+

* [DSE authentication]
  * [Plaintext/DSE]
  * [LDAP]
  * [GSSAPI (Kerberos)]
* [DSE geospatial types]
* [DSE graph integration]

### DSE v5.1+

* [DSE proxy authentication and execution]
* [DSE DateRange]

## Compatibility

This driver works exclusively with [DataStax Enterprise][DSE]. The current
version works with:

* [DataStax Enterprise][DSE] 4.7, 4.8, 5.0 and 5.1+
* PHP 5.6, PHP 7.0, and PHP 7.1
  * 32-bit (x86) and 64-bit (x64)
  * Thread safe (TS) and non-thread safe (NTS)
* Compilers: GCC 4.1.2+, Clang 3.4+, and MSVC 2010/2012/2013/2015

## Documentation

* [Home]
* [API]
* [Features]
* [Building and Testing]
* [Migration]

## Getting Help

* JIRA: https://datastax-oss.atlassian.net/browse/PHP (Assign "Component/s" field set to "DSE")
* Mailing List: https://groups.google.com/a/lists.datastax.com/forum/#!forum/php-driver-user
* DataStax Academy via Slack: https://academy.datastax.com/slack

## Feedback Requested

**Help us focus our efforts!** [Provide your input] on the DSE PHP Driver
Platform and Runtime Survey (we kept it short).

## Examples

The driver includes several examples in the [features][Features] directory.

## License
Copyright &copy; 2017 DataStax, Inc.

http://www.datastax.com/terms/datastax-dse-driver-license-terms

[DSE]: http://www.datastax.com/products/datastax-enterprise
[DataStax PHP driver for Apache Cassandra]: https://github.com/datastax/php-driver
[download server]: http://downloads.datastax.com/php-driver
[GitHub]: https://github.com/datastax/php-dse-driver
[Home]: http://docs.datastax.com/en/developer/php-driver-dse/latest
[API]: http://docs.datastax.com/en/developer/php-driver-dse/latest/api
[Features]: /features
[Building and Testing]: http://docs.datastax.com/en/developer/php-driver-dse/latest/building_testing
[Migration]: /features/migration
[Provide your input]: http://goo.gl/forms/HbSiIJ2tLP
[DSE authentication]: /features/authentication
[Plaintext/DSE]: features/authentication/dse.feature
[LDAP]: features/authentication/ldap.feature
[GSSAPI (Kerberos)]: /features/authentication/kerberos.feature
[DSE geospatial types]: /features/geotypes
[DSE graph integration]: /features/graph
[DSE proxy authentication and execution]: features/authentication/proxy
[DSE DateRange]: features/date_range
